Index: /trunk/sources/HeuristicLab.Optimizer/3.3/CreateExperimentDialog.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/CreateExperimentDialog.cs	(revision 13670)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/CreateExperimentDialog.cs	(revision 13671)
@@ -343,5 +343,6 @@
           selectAllCheckBox.Checked = treeViewNodes.Count() == instances.SelectMany(x => x.Value).Count();
           selectNoneCheckBox.Checked = !treeViewNodes.Any(x => x.Checked);
-        } finally { suppressCheckAllNoneEventHandling = false; }
+        }
+        finally { suppressCheckAllNoneEventHandling = false; }
         UpdateVariationsLabel();
       }
@@ -357,5 +358,6 @@
           }
         }
-      } finally { suppressTreeViewEventHandling = false; }
+      }
+      finally { suppressTreeViewEventHandling = false; }
     }
 
@@ -379,5 +381,6 @@
         try {
           node.Parent.Checked = allChecked;
-        } finally { suppressTreeViewEventHandling = false; }
+        }
+        finally { suppressTreeViewEventHandling = false; }
       }
     }
@@ -387,5 +390,6 @@
         if (selectAllCheckBox.Checked) {
           suppressCheckAllNoneEventHandling = true;
-          try { selectNoneCheckBox.Checked = false; } finally { suppressCheckAllNoneEventHandling = false; }
+          try { selectNoneCheckBox.Checked = false; }
+          finally { suppressCheckAllNoneEventHandling = false; }
           try {
             suppressTreeViewEventHandling = true;
@@ -396,5 +400,6 @@
               }
             }
-          } finally { suppressTreeViewEventHandling = false; }
+          }
+          finally { suppressTreeViewEventHandling = false; }
         }
         UpdateVariationsLabel();
@@ -406,5 +411,6 @@
         if (selectNoneCheckBox.Checked) {
           suppressCheckAllNoneEventHandling = true;
-          try { selectAllCheckBox.Checked = false; } finally { suppressCheckAllNoneEventHandling = false; }
+          try { selectAllCheckBox.Checked = false; }
+          finally { suppressCheckAllNoneEventHandling = false; }
           try {
             suppressTreeViewEventHandling = true;
@@ -415,5 +421,6 @@
               }
             }
-          } finally { suppressTreeViewEventHandling = false; }
+          }
+          finally { suppressTreeViewEventHandling = false; }
         }
         UpdateVariationsLabel();
@@ -720,8 +727,12 @@
           var node = new TreeNode(desc.Name) { Tag = desc };
           providerNode.Nodes.Add(node);
-          if (providerNode.Nodes.Count == 1)
-            nodes.Add(providerNode);
-        }
-        double progress = nodes.Count > 0 ? i / (double)nodes.Count : 0.0;
+        }
+
+        //Do not add instance providers without data descriptors
+        if (providerNode.Nodes.Count > 0) {
+          nodes.Add(providerNode);
+        }
+
+        double progress = nodes.Count > 0 ? i / (double)instanceProviders.Length : 0.0;
         instanceDiscoveryBackgroundWorker.ReportProgress((int)(100 * progress), provider.Name);
       }
@@ -744,9 +755,11 @@
         }
         selectNoneCheckBox.Checked = true;
-      } catch { }
+      }
+      catch { }
       try {
         SetMode(DialogMode.Normal);
         if (e.Error != null) MessageBox.Show(e.Error.Message, "Error occurred", MessageBoxButtons.OK, MessageBoxIcon.Error);
-      } catch { }
+      }
+      catch { }
     }
     #endregion
@@ -763,5 +776,6 @@
         try {
           AddParameterVariations(Optimizer, localExperiment, ref counter, totalVariations);
-        } catch (OperationCanceledException) {
+        }
+        catch (OperationCanceledException) {
           e.Cancel = true;
           return;
@@ -775,5 +789,6 @@
             try {
               ProblemInstanceManager.LoadData(provider, descriptor, (IProblemInstanceConsumer)algorithm.Problem);
-            } catch (Exception ex) {
+            }
+            catch (Exception ex) {
               failedInstances.AppendLine(descriptor.Name + ": " + ex.Message);
               failed = true;
@@ -788,5 +803,6 @@
                   AddParameterVariations(algorithm, localExperiment, ref counter, totalVariations);
                 }
-              } catch (OperationCanceledException) {
+              }
+              catch (OperationCanceledException) {
                 e.Cancel = true;
                 return;
@@ -939,5 +955,6 @@
           Close();
         }
-      } catch { }
+      }
+      catch { }
     }
     #endregion