Index: /trunk/sources/HeuristicLab.Algorithms.RandomSearch/3.3/RandomSearchAlgorithm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.RandomSearch/3.3/RandomSearchAlgorithm.cs	(revision 13676)
+++ /trunk/sources/HeuristicLab.Algorithms.RandomSearch/3.3/RandomSearchAlgorithm.cs	(revision 13677)
@@ -35,5 +35,5 @@
 
 namespace HeuristicLab.Algorithms.RandomSearch {
-  [Item("Random Search Algorithm", "An random search algorithm.")]
+  [Item("Random Search Algorithm (RS)", "An random search algorithm.")]
   [Creatable(CreatableAttribute.Categories.Algorithms, Priority = 150)]
   [StorableClass]
@@ -63,12 +63,12 @@
       get { return (IFixedValueParameter<MultiAnalyzer>)Parameters["Analyzer"]; }
     }
-    private IFixedValueParameter<IntValue> NumberOfSamplesParameter {
-      get { return (IFixedValueParameter<IntValue>)Parameters["NumberOfSamples"]; }
-    }
-    private IFixedValueParameter<IntValue> BatchSizeParameter {
-      get { return (IFixedValueParameter<IntValue>)Parameters["BatchSize"]; }
-    }
-    private IFixedValueParameter<IntValue> NumberOfBatchesParameter {
-      get { return (IFixedValueParameter<IntValue>)Parameters["NumberOfBatches"]; }
+    private IFixedValueParameter<IntValue> MaximumEvaluatedSolutionsParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters["MaximumEvaluatedSolutions"]; }
+    }
+    private IFixedValueParameter<IntValue> SampleSizeParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters["SampleSize"]; }
+    }
+    private IFixedValueParameter<IntValue> MaximumIterationsParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters["MaximumIterations"]; }
     }
     private IFixedValueParameter<MultiTerminator> TerminatorParameter {
@@ -89,15 +89,15 @@
       get { return AnalyzerParameter.Value; }
     }
-    public int NumberOfSamples {
-      get { return NumberOfSamplesParameter.Value.Value; }
-      set { NumberOfSamplesParameter.Value.Value = value; }
-    }
-    public int BatchSize {
-      get { return BatchSizeParameter.Value.Value; }
-      set { BatchSizeParameter.Value.Value = value; }
-    }
-    public int NumberOfBatches {
-      get { return NumberOfBatchesParameter.Value.Value; }
-      set { NumberOfBatchesParameter.Value.Value = value; }
+    public int MaximumEvaluatedSolutions {
+      get { return MaximumEvaluatedSolutionsParameter.Value.Value; }
+      set { MaximumEvaluatedSolutionsParameter.Value.Value = value; }
+    }
+    public int SampleSize {
+      get { return SampleSizeParameter.Value.Value; }
+      set { SampleSizeParameter.Value.Value = value; }
+    }
+    public int MaximumIterations {
+      get { return MaximumIterationsParameter.Value.Value; }
+      set { MaximumIterationsParameter.Value.Value = value; }
     }
     public MultiTerminator Terminators {
@@ -152,7 +152,7 @@
       Parameters.Add(new FixedValueParameter<BoolValue>("SetSeedRandomly", "True if the random seed should be set to a random value, otherwise false.", new BoolValue(true)));
       Parameters.Add(new FixedValueParameter<MultiAnalyzer>("Analyzer", "The operator used to analyze all individuals from all layers combined.", new MultiAnalyzer()));
-      Parameters.Add(new FixedValueParameter<IntValue>("NumberOfSamples", "The number of random samples the algorithm should evaluate.", new IntValue(1000)));
-      Parameters.Add(new FixedValueParameter<IntValue>("BatchSize", "The number of random samples that are evaluated (in parallel) until they are analyzed.", new IntValue(100)));
-      Parameters.Add(new FixedValueParameter<IntValue>("NumberOfBatches", "The number batch runs (iterations) that the algorithm will run.", new IntValue(10)) { Hidden = true });
+      Parameters.Add(new FixedValueParameter<IntValue>("MaximumEvaluatedSolutions", "The number of random samples the algorithm should evaluate.", new IntValue(1000)));
+      Parameters.Add(new FixedValueParameter<IntValue>("SampleSize", "The number of random samples that are evaluated (in parallel) per iteration.", new IntValue(100)));
+      Parameters.Add(new FixedValueParameter<IntValue>("MaximumIterations", "The number iterations that the algorithm will run.", new IntValue(10)) { Hidden = true });
       Parameters.Add(new FixedValueParameter<MultiTerminator>("Terminator", "The termination criteria that defines if the algorithm should continue or stop.", new MultiTerminator()) { Hidden = true });
       #endregion
@@ -187,5 +187,5 @@
       resultsCollector.Successor = solutionCreator;
 
-      solutionCreator.NumberOfSolutionsParameter.ActualName = BatchSizeParameter.Name;
+      solutionCreator.NumberOfSolutionsParameter.ActualName = SampleSizeParameter.Name;
       solutionCreator.ParallelParameter.Value.Value = true;
       solutionCreator.Successor = evaluationsCounter;
@@ -193,5 +193,5 @@
       evaluationsCounter.ValueParameter.ActualName = "EvaluatedSolutions";
       evaluationsCounter.Increment = null;
-      evaluationsCounter.IncrementParameter.ActualName = BatchSizeParameter.Name;
+      evaluationsCounter.IncrementParameter.ActualName = SampleSizeParameter.Name;
       evaluationsCounter.Successor = analyzerPlaceholder;
 
@@ -215,5 +215,5 @@
 
       #region Create terminators
-      evaluationsTerminator = new ComparisonTerminator<IntValue>("EvaluatedSolutions", ComparisonType.Less, NumberOfSamplesParameter) { Name = "Number of Samples" };
+      evaluationsTerminator = new ComparisonTerminator<IntValue>("EvaluatedSolutions", ComparisonType.Less, MaximumEvaluatedSolutionsParameter) { Name = "Evaluated solutions." };
       qualityTerminator = new SingleObjectiveQualityTerminator() { Name = "Quality" };
       executionTimeTerminator = new ExecutionTimeTerminator(this, new TimeSpanValue(TimeSpan.FromMinutes(5)));
@@ -312,7 +312,7 @@
       singleObjectiveQualityAnalyzer.CurrentBestQualityParameter.NameChanged += QualityAnalyzer_CurrentBestQualityParameter_NameChanged;
 
-      NumberOfSamplesParameter.Value.ValueChanged += NumberOfSamples_ValueChanged;
-      BatchSizeParameter.Value.ValueChanged += BatchSize_ValueChanged;
-      NumberOfBatchesParameter.Value.ValueChanged += NumberOfBatches_ValueChanged;
+      MaximumEvaluatedSolutionsParameter.Value.ValueChanged += MaximumEvaluatedSolutions_ValueChanged;
+      SampleSizeParameter.Value.ValueChanged += SampleSize_ValueChanged;
+      MaximumIterationsParameter.Value.ValueChanged += MaximumIterations_ValueChanged;
     }
     private void ParameterizeSolutionsCreator() {
@@ -339,5 +339,5 @@
           op.IterationsParameter.ActualName = "BatchNumber";
           op.IterationsParameter.Hidden = true;
-          op.MaximumIterationsParameter.ActualName = NumberOfBatchesParameter.Name;
+          op.MaximumIterationsParameter.ActualName = MaximumIterationsParameter.Name;
         }
       }
@@ -354,12 +354,12 @@
       }
     }
-    private void NumberOfSamples_ValueChanged(object sender, EventArgs e) {
-      NumberOfBatches = NumberOfSamples / BatchSize;
-    }
-    private void BatchSize_ValueChanged(object sender, EventArgs e) {
-      NumberOfBatches = NumberOfSamples / BatchSize;
-    }
-    private void NumberOfBatches_ValueChanged(object sender, EventArgs e) {
-      BatchSize = NumberOfSamples / NumberOfBatches;
+    private void MaximumEvaluatedSolutions_ValueChanged(object sender, EventArgs e) {
+      MaximumIterations = MaximumEvaluatedSolutions / SampleSize;
+    }
+    private void SampleSize_ValueChanged(object sender, EventArgs e) {
+      MaximumIterations = MaximumEvaluatedSolutions / SampleSize;
+    }
+    private void MaximumIterations_ValueChanged(object sender, EventArgs e) {
+      SampleSize = MaximumEvaluatedSolutions / MaximumIterations;
     }
     #endregion