Index: trunk/sources/HeuristicLab.Clients.OKB.Views/3.3/HeuristicLab.Clients.OKB.Views-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Clients.OKB.Views/3.3/HeuristicLab.Clients.OKB.Views-3.3.csproj	(revision 13692)
+++ trunk/sources/HeuristicLab.Clients.OKB.Views/3.3/HeuristicLab.Clients.OKB.Views-3.3.csproj	(revision 13693)
@@ -286,4 +286,10 @@
       <DependentUpon>OKBRunView.cs</DependentUpon>
     </Compile>
+    <Compile Include="RunCreation\Views\SingleObjectiveOKBSolutionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="RunCreation\Views\SingleObjectiveOKBSolutionView.Designer.cs">
+      <DependentUpon>SingleObjectiveOKBSolutionView.cs</DependentUpon>
+    </Compile>
     <None Include="Plugin.cs.frame" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
Index: trunk/sources/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/SingleObjectiveOKBSolutionView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/SingleObjectiveOKBSolutionView.Designer.cs	(revision 13693)
+++ trunk/sources/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/SingleObjectiveOKBSolutionView.Designer.cs	(revision 13693)
@@ -0,0 +1,148 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Clients.OKB.RunCreation.Views {
+  partial class SingleObjectiveOKBSolutionView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.refreshButton = new System.Windows.Forms.Button();
+      this.uploadButton = new System.Windows.Forms.Button();
+      this.solutionGroupBox = new System.Windows.Forms.GroupBox();
+      this.qualityTextBox = new System.Windows.Forms.TextBox();
+      this.qualityLabel = new System.Windows.Forms.Label();
+      this.solutionViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.solutionGroupBox.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // refreshButton
+      // 
+      this.refreshButton.Location = new System.Drawing.Point(3, 3);
+      this.refreshButton.Name = "refreshButton";
+      this.refreshButton.Size = new System.Drawing.Size(26, 23);
+      this.refreshButton.TabIndex = 0;
+      this.refreshButton.Text = "Refresh";
+      this.refreshButton.UseVisualStyleBackColor = true;
+      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
+      // 
+      // uploadButton
+      // 
+      this.uploadButton.Location = new System.Drawing.Point(35, 3);
+      this.uploadButton.Name = "uploadButton";
+      this.uploadButton.Size = new System.Drawing.Size(26, 23);
+      this.uploadButton.TabIndex = 0;
+      this.uploadButton.Text = "Upload";
+      this.uploadButton.UseVisualStyleBackColor = true;
+      this.uploadButton.Click += new System.EventHandler(this.uploadButton_Click);
+      // 
+      // solutionGroupBox
+      // 
+      this.solutionGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.solutionGroupBox.Controls.Add(this.solutionViewHost);
+      this.solutionGroupBox.Controls.Add(this.qualityTextBox);
+      this.solutionGroupBox.Controls.Add(this.qualityLabel);
+      this.solutionGroupBox.Location = new System.Drawing.Point(3, 32);
+      this.solutionGroupBox.Name = "solutionGroupBox";
+      this.solutionGroupBox.Size = new System.Drawing.Size(703, 452);
+      this.solutionGroupBox.TabIndex = 3;
+      this.solutionGroupBox.TabStop = false;
+      this.solutionGroupBox.Text = "Solution";
+      // 
+      // qualityTextBox
+      // 
+      this.qualityTextBox.Location = new System.Drawing.Point(58, 19);
+      this.qualityTextBox.Name = "qualityTextBox";
+      this.qualityTextBox.ReadOnly = true;
+      this.qualityTextBox.Size = new System.Drawing.Size(229, 20);
+      this.qualityTextBox.TabIndex = 4;
+      // 
+      // qualityLabel
+      // 
+      this.qualityLabel.AutoSize = true;
+      this.qualityLabel.Location = new System.Drawing.Point(10, 22);
+      this.qualityLabel.Name = "qualityLabel";
+      this.qualityLabel.Size = new System.Drawing.Size(42, 13);
+      this.qualityLabel.TabIndex = 3;
+      this.qualityLabel.Text = "Quality:";
+      // 
+      // solutionViewHost
+      // 
+      this.solutionViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.solutionViewHost.Caption = "View";
+      this.solutionViewHost.Content = null;
+      this.solutionViewHost.Enabled = false;
+      this.solutionViewHost.Location = new System.Drawing.Point(6, 45);
+      this.solutionViewHost.Name = "solutionViewHost";
+      this.solutionViewHost.ReadOnly = false;
+      this.solutionViewHost.Size = new System.Drawing.Size(691, 401);
+      this.solutionViewHost.TabIndex = 5;
+      this.solutionViewHost.ViewsLabelVisible = true;
+      this.solutionViewHost.ViewType = null;
+      // 
+      // SingleObjectiveOKBSolutionView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.solutionGroupBox);
+      this.Controls.Add(this.uploadButton);
+      this.Controls.Add(this.refreshButton);
+      this.Name = "SingleObjectiveOKBSolutionView";
+      this.Size = new System.Drawing.Size(709, 487);
+      this.solutionGroupBox.ResumeLayout(false);
+      this.solutionGroupBox.PerformLayout();
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button refreshButton;
+    private System.Windows.Forms.Button uploadButton;
+    private System.Windows.Forms.GroupBox solutionGroupBox;
+    private MainForm.WindowsForms.ViewHost solutionViewHost;
+    private System.Windows.Forms.TextBox qualityTextBox;
+    private System.Windows.Forms.Label qualityLabel;
+  }
+}
Index: trunk/sources/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/SingleObjectiveOKBSolutionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/SingleObjectiveOKBSolutionView.cs	(revision 13693)
+++ trunk/sources/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/SingleObjectiveOKBSolutionView.cs	(revision 13693)
@@ -0,0 +1,93 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common.Resources;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using System;
+using System.Globalization;
+
+namespace HeuristicLab.Clients.OKB.RunCreation.Views {
+  [View("OKB Solution View (single-objective)")]
+  [Content(typeof(SingleObjectiveOKBSolution), IsDefaultView = true)]
+  public partial class SingleObjectiveOKBSolutionView : ItemView {
+
+    public new SingleObjectiveOKBSolution Content {
+      get { return (SingleObjectiveOKBSolution)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public SingleObjectiveOKBSolutionView() {
+      InitializeComponent();
+      refreshButton.Text = string.Empty;
+      refreshButton.Image = VSImageLibrary.Refresh;
+      uploadButton.Text = string.Empty;
+      uploadButton.Image = VSImageLibrary.PublishToWeb;
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.QualityChanged += ContentOnQualityChanged;
+      Content.SolutionChanged += ContentOnSolutionChanged;
+    }
+
+    protected override void DeregisterContentEvents() {
+      base.DeregisterContentEvents();
+      Content.QualityChanged -= ContentOnQualityChanged;
+      Content.SolutionChanged -= ContentOnSolutionChanged;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        qualityTextBox.Text = string.Empty;
+        solutionViewHost.Content = null;
+      } else {
+        qualityTextBox.Text = Content.Quality.ToString(CultureInfo.CurrentCulture.NumberFormat);
+        solutionViewHost.Content = Content.Solution;
+      }
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      refreshButton.Enabled = Content != null & !Locked && !ReadOnly && Content.SolutionId != -1;
+      uploadButton.Enabled = Content != null && !Locked && !ReadOnly && Content.SolutionId == -1;
+    }
+
+    private void ContentOnSolutionChanged(object sender, EventArgs eventArgs) {
+      solutionViewHost.Content = Content.Solution;
+    }
+
+    private void ContentOnQualityChanged(object sender, EventArgs eventArgs) {
+      qualityTextBox.Text = Content.Quality.ToString(CultureInfo.CurrentCulture.NumberFormat);
+    }
+
+    private void refreshButton_Click(object sender, System.EventArgs e) {
+      Content.Download(Content.SolutionId);
+      SetEnabledStateOfControls();
+    }
+
+    private void uploadButton_Click(object sender, System.EventArgs e) {
+      Content.Upload();
+      SetEnabledStateOfControls();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBProblem.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBProblem.cs	(revision 13692)
+++ trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBProblem.cs	(revision 13693)
@@ -174,4 +174,7 @@
       if (ProblemId != -1) {
         Solutions.AddRange(RunCreationClient.Instance.GetSolutions(ProblemId).Select(OKBSolution.Convert));
+        foreach (var sol in Solutions) {
+          sol.DownloadData();
+        }
       }
     }
Index: trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBSolution.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBSolution.cs	(revision 13692)
+++ trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/OKBSolution.cs	(revision 13693)
@@ -73,4 +73,5 @@
 
     public abstract void Download(long solutionId);
+    public abstract void DownloadData();
 
     public abstract void Upload();
Index: trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/SingleObjectiveOKBSolution.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/SingleObjectiveOKBSolution.cs	(revision 13692)
+++ trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/SingleObjectiveOKBSolution.cs	(revision 13693)
@@ -75,4 +75,10 @@
     }
 
+    public override void DownloadData() {
+      using (var stream = new MemoryStream(RunCreationClient.Instance.GetSolutionData(SolutionId))) {
+        Solution = XmlParser.Deserialize<IItem>(stream);
+      }
+    }
+
     public override void Upload() {
       if (SolutionId != -1) throw new InvalidOperationException("Solution exists already.");